package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.Opinion;
import com.ff.weijinxiao.repository.OpinionRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class OpinionService {

    @Resource
    private OpinionRepository opinionRepository;

    /**
     * 创建实体
     *
     * @param opinion
     */
    public Opinion saveOpinion(Opinion opinion) {
        return opinionRepository.save(opinion);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public Opinion findById(Integer id) {
        Optional<Opinion> optional = opinionRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public void deleteById(Integer id) {
        opinionRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<Opinion> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return opinionRepository.findAll(SpecificationUtil.buildSpecification(param, Opinion.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<Opinion> findList(Map<String, Object> param) {
        return opinionRepository.findAll(SpecificationUtil.buildSpecification(param, Opinion.class));
    }

}
